;********************************************************************
; INPUT MODULE                                                      *
;********************************************************************
;********************************************************************
; Subroutine:   InputUpdate
;********************************************************************
InputUpdate
                ;joystick scan
                lda #JOYSTICK_PORT_2
                sta TEDREG08
                lda TEDREG08
                sta GAMEPORTTHISFRAME
                eor GAMEPORTLASTFRAME
                sta GAMEPORTDIFF
                lda FIREDELAY
                beq .inputupdate_delayzero
                dec FIREDELAY
.inputupdate_delayzero
                lda GAMEPORTTHISFRAME
                sta GAMEPORTLASTFRAME
                rts

;********************************************************************
; Subroutine:   GetFirePressed
;********************************************************************
GetFirePressed
                lda #$01
                sta FIREBLIP ;clear Fire flag
                ;is fire held?
                lda GAMEPORTTHISFRAME
                and #FIRE_MASK
                bne .getfirepressed_notheld
.getfirepressed_held
                ;is this 1st frame?
                lda GAMEPORTDIFF
                and #FIRE_MASK
                beq .getfirepressed_notfirst
                lda #$00
                sta FIREBLIP ;fire
                ;get new random seed for only one time ***************
                lda SEEDVALUEUPDATED                    ;
                cmp #FALSE                              ;
                bne .getfirepressed_skipnewseed         ;
                ;current horizontal scan pos            ;
                lda TEDREG1E                            ;
                ;seed, can be anything except 0         ;
                ora #%00000001                          ;
                sta NEWRANDOMSEED                       ;
                jsr StoreSeed                           ;
                jsr GetRandomValue                      ;
                ;never set back to FALSE                ;
                lda #TRUE                               ;
                sta SEEDVALUEUPDATED                    ;
.getfirepressed_skipnewseed
                ;reset delay
                lda #FIRE_DELAY_MAX
                sta FIREDELAY
.getfirepressed_notfirst
                ;is the delay zero?
                lda FIREDELAY
                bne .getfirepressed_notheld
                lda #$00
                sta FIREBLIP ;fire
                ;reset delay
                lda #FIRE_DELAY_MAX
                sta FIREDELAY
.getfirepressed_notheld 
                lda FIREBLIP
                ;test with bne on return
                rts

;********************************************************************
; INPUT MODULE END                                                  *
;********************************************************************