;********************************************************************
; INTERRUPT MODULE                                                  *
;********************************************************************
;********************************************************************
; IRQ interrupt handler
;********************************************************************
InterruptHandler
                pha
                txa
                pha
                tya
                pha
                ;check raster interrupt status
                lda TEDREG09
                and #$02
                sta TEDREG09
                bne .interrupthandler_go
                beq .interrupthandler_exit

;********************************************************************
;A raster interrupt has triggered ***********************************
;********************************************************************
.interrupthandler_go
                ;lda #PUR
                ;sta TEDREG19
                cld
                ;increment 8 bit general frame counter
                inc FRAMECOUNTER
                ;increment sw timer counters and check thresholds
                jsr UpdateAllTimers
                ;update the background startfield animation
                jsr StarsUpdate
                ;update the bullets queue
                jsr BulletsUpdate
                ;handle the mothership - bullet collisions
                lda CURRENTWAVE
                cmp #FLOW_WAVE_3
                bne .interrupthandler_skip
                lda #$00
                sta CURRENTBUNKERSEDGEINDEX
.interrupthandler_loop
                jsr MothershipBulletCollisions
                ;loop for each bunkers edge
                inc CURRENTBUNKERSEDGEINDEX
                lda CURRENTBUNKERSEDGEINDEX
                cmp #NO_OF_BUNKER_EDGES
                bne .interrupthandler_loop
.interrupthandler_skip
                ;play the sounds and tunes
                jsr SoundUpdate
                ;irq routines are finished
                lda #$01
                sta WAITIRQ
                ;lda #BLK
                ;sta TEDREG19
.interrupthandler_exit
                pla
                tay
                pla
                tax
                pla
                rti

;********************************************************************
; Fanke NMI handler
;********************************************************************
; restarts the programm if reset key pressed
FakeNMI
                sei
                ;mute sound
                lda #$00
                sta TEDREG11
                ;reset stack pointer
                ldx #$00
                txs
                jmp .main_init+1

;********************************************************************
; INTERRUPT MODULE END                                              *
;********************************************************************